/****************************************************************
 ****************************************************************

Autor: Srdjan Vukmirovic, Tijana Sukilovic
e-mail: vsrdjan@matf.bg.ac.yu, tijana@matf.bg.ac.yu
Datum: 4.11.2007.
Verzija:  radna

Izmene: 6.11.2008. - sada radi bolje ;)
                   - pravi i html fajl koji poziva JavaView
        6.12.2008. - omogucava poziv funkcije iz petlje

Ovo je heder koji se u kursu Geometrija na Matematickom Fakultetu,
u Beogradu.
Glavni deo su funkcije
nacrtaj(ime_fajla, objekat za crtanje)
prikazi(ime_fajla)

Prva funkcija formira niz objekata tipa Tacka, Prava, Duz i Krug (definisane ispod)

Druga funkcija upisuje clanove niza u fajl (ime_fajla).
Fajl je tipa .jvx u XMLu Otvara se besplatnim softverom JavaView
(www.javaview.de). Funkcija pravi i html fajl koji poziva jvx fajl.
Potrebno je iskopirati fajlove javaview.jar i displej.jvd u isti 
direktorijum, 

*******************************************************************/


#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include <float.h>
#include <string.h>

/* Definicije struktura  */

typedef struct {
double x;
double y;
}  Tacka;

typedef struct {
Tacka start;
Tacka pravac;
}  Prava;

typedef struct {
Tacka centar;
double r;
}  Krug;

typedef struct {
Tacka start;
Tacka end;
}  Duz;

typedef struct obj{
	char name[30];
	char type;
	double *parametars;
	struct obj *next;
} Objekti;
 	
Objekti* Niz=NULL; //niz objekata
Objekti* last=NULL; //poslednji clan niza
Objekti* lines=NULL; //poslednji clan niza koji nije prava

int ind=0; 

const double pi = 3.141592;
const double eps = 0.000001;

void nacrtaj(char *fname, Tacka t)
{
	Objekti* novi;

	novi=(Objekti*)malloc (sizeof (Objekti));
	novi->parametars=(double*)malloc(2*sizeof(double));
	
	strcpy(novi->name,fname);
	novi->type='t';
	novi->parametars[0]=t.x;
	novi->parametars[1]=t.y;

	novi->next=NULL;

	if (last)
	{
		Objekti* temp;
		temp=lines->next;
		lines->next = novi;
		novi->next=temp;
	}	
    else
	{
		Niz=(Objekti*)malloc (sizeof (Objekti));
		Niz->parametars=(double*)malloc(2*sizeof(double));

		strcpy(Niz->name,fname);
		Niz->type='t';
		Niz->parametars[0]=0;
		Niz->parametars[1]=0;
		Niz->next = novi;
		
		lines = novi;
		last = novi;
	}	
}

void nacrtaj(char *fname, Krug k)
{
	Objekti* novi;

	novi=(Objekti*)malloc (sizeof (Objekti));
	novi->parametars=(double*)malloc(3*sizeof(double));

	strcpy(novi->name,fname);
	novi->type='k';
	novi->parametars[0]=k.centar.x;
	novi->parametars[1]=k.centar.y;
	novi->parametars[2]=k.r;
	novi->next=NULL;

	if (last)
	{	
		Objekti* temp;
		temp=lines->next;
		lines->next = novi;
		novi->next=temp;
	}	
    else
	{
		Niz=(Objekti*)malloc (sizeof (Objekti));
		Niz->parametars=(double*)malloc(2*sizeof(double));

		strcpy(Niz->name,fname);
		Niz->type='t';
		Niz->parametars[0]=0;
		Niz->parametars[1]=0;
		Niz->next = novi;
		
		lines = novi;
		last = novi;
	}
}

void nacrtaj(char *fname, Duz d)
{
	Objekti* novi;

	novi=(Objekti*)malloc (sizeof (Objekti));
	novi->parametars=(double*)malloc(4*sizeof(double));

	strcpy(novi->name,fname);
    novi->type='d';
	novi->parametars[0]=d.start.x;
	novi->parametars[1]=d.start.y;
	novi->parametars[2]=d.end.x;
	novi->parametars[3]=d.end.y;
	novi->next=NULL;

	if(last)
	{
		Objekti* temp;
		temp=lines->next;
		lines->next = novi;
		novi->next=temp;
	}
    else
	{
		Niz=(Objekti*)malloc (sizeof (Objekti));
		Niz->parametars=(double*)malloc(2*sizeof(double));

		strcpy(Niz->name,fname);
		Niz->type='t';
		Niz->parametars[0]=0;
		Niz->parametars[1]=0;
		Niz->next = novi;

		lines = novi;
		last = novi;
	}
}


void nacrtaj(char *fname, Prava p)
{	
	Objekti* novi;

	novi=(Objekti*)malloc (sizeof (Objekti));
	novi->parametars=(double*)malloc(4*sizeof(double));

	strcpy(novi->name,fname);
	novi->type='p';
	novi->parametars[0]=p.start.x;
	novi->parametars[1]=p.start.y;
	novi->parametars[2]=p.pravac.x;
	novi->parametars[3]=p.pravac.y;
	novi->next=NULL;

	if (last)
         last->next = novi;
    else
	{
		Niz=(Objekti*)malloc (sizeof (Objekti));
		Niz->parametars=(double*)malloc(2*sizeof(double));

		strcpy(Niz->name,fname);
		Niz->type='t';
		Niz->parametars[0]=0;
		Niz->parametars[1]=0;
		Niz->next = novi;
		
		lines = novi;
	}

	last = novi;
}

int prikazi(char *fname)
{
	int i,err=0;
	double p1x, p1y, p2x, p2y;

	// Promenljive za odredjivanje granica crteza.  Potrebne su zbog crtanja pravih
	double maxy = -FLT_MAX;
	double miny = FLT_MAX; 	
	double minx = FLT_MAX;	
	double maxx = -FLT_MAX;
	
	char jvx_fajl[30]; 
	char htm_fajl[30];
	
	strcpy(jvx_fajl, fname);
	strcat(jvx_fajl, ".jvx");
	strcpy(htm_fajl, fname);
	strcat(htm_fajl, ".htm");
	
	FILE *fp = fopen(jvx_fajl, "w");
	
	fprintf(fp, "<?xml>\n");
	fprintf(fp, "<jvx-model>\n");
	fprintf(fp, "<title>Zadatak iz Geometrije</title>\n");
	fprintf(fp, "<geometries>\n");
	 
	Objekti* temp;

	if(!ind)  //zbog zumiranja je crtana lazna tacka - sad je izbacujemo iz objekata za crtanje
	{
		ind=1;
		Niz=Niz->next;
	}

	for (temp=Niz; temp!=NULL; temp=temp->next)
	{
		if(!strcmp(temp->name,fname))
		{
			switch (temp->type){
			case 't':              // argument je tacka 
				if (temp->parametars[0] < minx) minx = temp->parametars[0];
				if (temp->parametars[0] > maxx) maxx = temp->parametars[0];
				if (temp->parametars[1] < miny) miny = temp->parametars[1];
				if (temp->parametars[1] > maxy) maxy = temp->parametars[1];
				
				fprintf(fp, "<geometry>\n");
				fprintf(fp, "<pointSet dim=\"2\" point=\"show\">\n");
				fprintf(fp, "<points>\n");
				fprintf(fp, "<p>%f %f </p>\n", temp->parametars[0], temp->parametars[1]);
				fprintf(fp, "</points>\n");
				fprintf(fp, "</pointSet>\n");
				fprintf(fp, "</geometry>\n");
				break;
			case 'k':                  // argument je krug
				if (temp->parametars[0] - temp->parametars[2]  < minx) minx = temp->parametars[0] - temp->parametars[2];
				if (temp->parametars[0] + temp->parametars[2]  > maxx) maxx = temp->parametars[0] + temp->parametars[2];
				if (temp->parametars[1] - temp->parametars[2]  < miny) miny = temp->parametars[1] - temp->parametars[2];
				if (temp->parametars[1] + temp->parametars[2]  > maxy) maxy = temp->parametars[1] + temp->parametars[2];

				fprintf(fp, "<geometry>\n");
				fprintf(fp, "<pointSet dim=\"2\" point=\"hide\">\n");
				fprintf(fp, "<points>\n");
				// krug se aproksimira linijama
				for(i=0; i<=40; i++){
					double x0 = temp->parametars[0];
					double y0 = temp->parametars[1];
					double r = temp->parametars[2];
					fprintf(fp, "<p>%f %f </p>\n", x0 + r * cos ((pi/20) *i),  y0 +  r * sin ((pi/20) *i));
				}
				fprintf(fp, "</points>\n");
				fprintf(fp, "</pointSet>\n");
				fprintf(fp, "<lineSet line=\"show\">\n");
				fprintf(fp, "<lines>\n");
				for(i=0; i<40; i++){
					fprintf(fp,  "<l>%i  %i</l>", i, i+1);
				}
				fprintf(fp, "</lines>\n");
				fprintf(fp, "</lineSet>\n");
				fprintf(fp, "</geometry>\n");
				break;		
			case 'd':             // argument je duz 
				if (temp->parametars[0] < minx) minx = temp->parametars[0];
				if (temp->parametars[0] > maxx) maxx = temp->parametars[0];
				if (temp->parametars[2] < minx) minx = temp->parametars[2];
				if (temp->parametars[2] > maxx) maxx = temp->parametars[2];
				if (temp->parametars[1] < miny) miny = temp->parametars[1];
				if (temp->parametars[1] > maxy) maxy = temp->parametars[1];
				if (temp->parametars[3] < miny) miny = temp->parametars[3];
				if (temp->parametars[3] > maxy) maxy = temp->parametars[3];
				
				fprintf(fp, "<geometry>\n");
				fprintf(fp, "<pointSet dim=\"2\" point=\"hide\">\n");
				fprintf(fp, "<points>\n");
				fprintf(fp, "<p>%f %f </p>\n", temp->parametars[0], temp->parametars[1]);
				fprintf(fp, "<p>%f %f </p>\n", temp->parametars[2], temp->parametars[3]);
				fprintf(fp, "</points>\n");
				fprintf(fp, "</pointSet>\n");
				fprintf(fp, "<lineSet line=\"show\">\n");
				fprintf(fp, "<lines>\n");
				fprintf(fp,  "<l>0 1</l>");
				fprintf(fp, "</lines>\n");
				fprintf(fp, "</lineSet>\n");
				fprintf(fp, "</geometry>\n");
				break;
			
			case 'p':   // argument je prava;ona se crta kodom koji sledi ispod 
				if (temp->parametars[0] < minx) minx = temp->parametars[0];
				if (temp->parametars[0] > maxx) maxx = temp->parametars[0];
				if (temp->parametars[1] < miny) miny = temp->parametars[1];
				if (temp->parametars[1] > maxy) maxy = temp->parametars[1];
				
				if(ind) // koliko prave strce van konacnih objekata
				{
					ind=0;
					maxx = maxx + 0.8 * (maxx - minx);
					minx = minx - 0.8 * (maxx - minx);
					maxy = maxy + 0.8 * (maxy - miny);
					miny = miny - 0.8 * (maxy - miny);
				}
				
				if (fabs(temp->parametars[2]) < eps)
				{p1x = temp->parametars[0]; p1y = maxy; p2x = temp->parametars[0]; p2y = miny;}
				else if (fabs(temp->parametars[3]) < eps)
				{p1x = minx; p1y = temp->parametars[1] ; p2x = maxx; p2y = temp->parametars[1];}
				else{                      
					// prava je nagnuta nalevo 
					if ((temp->parametars[2]) * (temp->parametars[3]) <0){
						p1x = minx;
						p1y = temp->parametars[1] + ((minx - temp->parametars[0])/(temp->parametars[2]))*(temp->parametars[3]);
						if(p1y >maxy){
							p1y = maxy;
							p1x = temp->parametars[0] + ((maxy - temp->parametars[1])/(temp->parametars[3]))*(temp->parametars[2]);
						}
						p2x = maxx;
						p2y = temp->parametars[1] + ((maxx - temp->parametars[0])/(temp->parametars[2]))*(temp->parametars[3]);
						if(p2y <miny){
							p2y = miny;
							p2x = temp->parametars[0] + ((miny - temp->parametars[1])/(temp->parametars[3]))*(temp->parametars[2]);
						}
					}
					// prava je nagnuta nadesno 
					else{       
						p1x = minx;
						p1y = temp->parametars[1] + ((minx - temp->parametars[0])/(temp->parametars[2]))*(temp->parametars[3]);
						if(p1y <miny){
							p1y = miny;
							p1x = temp->parametars[0] + ((miny - temp->parametars[1])/(temp->parametars[3]))*(temp->parametars[2]);
						}
						p2x = maxx;
						p2y = temp->parametars[1] + ((maxx - temp->parametars[0])/(temp->parametars[2]))*(temp->parametars[3]);
						if(p2y>maxy){
							p2y = maxy;
							p2x = temp->parametars[0] + ((maxy - temp->parametars[1])/(temp->parametars[3]))*(temp->parametars[2]);
						}
					}
				}
				fprintf(fp, "<geometry>\n");
				fprintf(fp, "<pointSet dim=\"2\" point=\"hide\">\n");
				fprintf(fp, "<points>\n");
				fprintf(fp, "<p> %f %f </p>\n", p1x, p1y);
				fprintf(fp, "<p>%f %f </p>\n", p2x, p2y);
				fprintf(fp, "</points>\n");
				fprintf(fp, "</pointSet>\n");
				fprintf(fp, "<lineSet line=\"show\">\n");
				fprintf(fp, "<lines>\n");
				fprintf(fp,  "<l>0 1</l>");
				fprintf(fp, "</lines>\n");
				fprintf(fp, "</lineSet>\n");
				fprintf(fp, "</geometry>\n");
				break;
			default:
				err = 1;
				break;
			}
		}
	}
	
	fprintf(fp, "</geometries>");
	fprintf(fp, "</jvx-model>");
	fclose(fp);
	if(!err) printf("Geometrijski objekti  upisani u fajl %s.\n\n", jvx_fajl);
	fp = fopen(htm_fajl, "w");
	fprintf(fp, "<html>\n");
	fprintf(fp, "<head><title>Geometrija - prikaz zadatka</title></head>\n");
	fprintf(fp, "<body>\n");
	fprintf(fp, "<applet height=\"600\" archive=\"javaview.jar\" width=\"800\" code=\"javaview.class\">\n");
	fprintf(fp, "<param name=model value=\"");
	fprintf(fp, jvx_fajl);
	fprintf(fp, "\">\n");
	fprintf(fp, "<param name=displayFile value=\"displej.jvd\">\n");
	fprintf(fp, "</applet>\n");
	fprintf(fp,	"</body>\n");
	fprintf(fp, "</html>\n");
	fclose(fp);

	ind=1;

	if(!err) printf("Otvoriti fajl %s.\n\n", htm_fajl);
	return err;
}
